# -*- coding: utf-8 -*-

from imio.urban.dataimport.mapping import table

VALUES_MAPS = {

'type_map': table({
'header'  : ['portal_type',       'abreviation'],
'N'       : ['BuildLicence',      'PU'],
'PU'      : ['UniqueLicence',     'U'],
'PS'      : ['',                  ''],
'PE'        : ['',                  ''],
'D'        : ['',                  ''],
''        : ['',                  ''],
''        : ['',                  ''],
}),

'state_map': {
    'autorisé': 'accepted',
    'recevable': 'accepted',
    'refusé': 'refused',
    'refusé tacite': 'refused',
    'refusé par défaut': 'refused',
    'irrecevable': 'refused',
    'sans suite': 'retired',
    'abandonné': 'retired',
},

'eventtype_id_map': table({
    'header'       : ['decision_event',],
    'EnvClassThree': ['demande-recevable',],
    'EnvClassTwo'  : ['decision',],
    'EnvClassOne'  : ['decision',],
    'UniqueLicence': ['decision',],
    'CODT_UniqueLicence': ['decision-finale',],
    'EnvClassBordering': ['decision-finale',],
}),

'person_title_map': {
    'monsieur': 'mister',
    'm.': 'mister',
    'm': 'mister',
    'dr': 'mister',
    'me': 'mister',
    'ms': 'misters',
    'mrs': 'misters',
    'messieurs': 'misters',
    'madame': 'madam',
    'mme': 'madam',
    'mesdames': 'ladies',
    'mmes': 'ladies',
    'mesdemoiselles': 'ladies',
    'mademoiselle': 'madam',
    'melle': 'madam',
    'ms et mmes': 'madam_and_mister',
    'mr et mme': 'madam_and_mister',
    'm. et mme': 'madam_and_mister',
    'm. et mmes': 'madam_and_mister',
    'm. et mme.': 'madam_and_mister',
    'm. et melle': 'madam_and_mister',
    'mme et m.': 'madam_and_mister',
    'melle et m.': 'madam_and_mister',
    'maître': 'master',
},

'externaldecisions_map': {
    'favorable': 'favorable',
    'fav': 'favorable',
    'favorable conditionnelle': 'favorable-conditionnel',
    'favorable conditionnel': 'favorable-conditionnel',
    'fav conditionnel': 'favorable-conditionnel',
    'fav cond': 'favorable-conditionnel',
    'défavorable': 'defavorable',
    'réputé favorable par défaut': 'favorable-defaut',
},

'allowed_env_bordering': [
    '1/4/161',
    '1/4/164',
    '1/419C38',
    '1/4/233',
    '1/424N5',
    '1/4/308',
    '1/4/317',
    '1/4/408',
    '1/4/411',
    '1/4/438',
    '1/4/444',
    '1/4/451',
    '1/4/452',
    '1/4/465',
    '1/4/471',
    '1/4/475',
    '1/4/476',
    '1/4/490',
    '1/4/497',
    '1/4/509',
    '1/4/510',
    '1/4/511',
    '1/4/512',
    '1/4/513',
    '1/4/521',
    '1/4/531',
    '1/4/534',
    '1/4/60',
],

'eventtitle_map': {
    1: "PROVOCATION - DEMANDE DE L'INSPECTEUR",
    2: "PROVOCATION - ENVOI/REMISE DES DOCUMENTS A L'EXPLOITANT",
    4: "PROVOCATION - 1ER RAPPEL A L'EXPLOITANT",
    5: "PROVOCATION - CONVOCATION DE L'EXPLOITANT",
    6: "PROVOCATION - MESURES AVANT FERMETURE",
    7: "PROVOCATION - PROPOSITION D'UN ARRETE DE FERMETURE",
    8: "PROVOCATION - ARRETE DE FERMETURE (ART.22.1)",
    9: "PROVOCATION - NOTIFICATION DE L'ARRETE DE FERMETURE",
    90: "DEPOT IRREGULIER DU DOSSIER",
    95: "ENVOI DU DOSSIER DEPOSE IRREGULIEREMENT A L'IMPETRANT",
    96: "ENVOI DU DOSSIER DEPOSE IRREGUL. A L'AUTORITE COMPETENTE",
    101: "DEPOT REGULIER DU DOSSIER (COMPLET ET/OU INCOMPLET)",
    102: "VISA DE RECEPTION DE L'INSPECTEUR",
    103: "DOC. MANQUANTS - RECLAMATION A L'IMPETRANT",
    104: "DOC. MANQUANTS - 1ER RAPPEL A L'IMPETRANT",
    105: "DOC. MANQUANTS - CONVOCATION DE L'IMPETRANT",
    106: "DOC. MANQUANTS - MESURES AVANT FERMETURE",
    107: "DOC. MANQUANTS - PROPOSITION D'UN ARRETE DE FERMETURE",
    108: "DOC. MANQUANTS - ARRETE DE FERMETURE (ART.22.1)",
    109: "DOC. MANQUANTS - NOTIFICATION DE L'ARRETE DE FERMETURE",
    110: "",
    117: "DROIT CONSTATE POUR LE RECEVEUR COMMUNAL",
    119: "DOSSIER COMPLET EXCEPTE LES TAXES/REDEVANCES",
    120: "DOSSIER COMPLET",
    130: "ACCORD DE PRINCIPE DE L'INSPECTEUR",
    139: "ETUDE D'INCIDENCE-UNICITE DEMANDEE PAR L'IMPETRANT",
    140: "ETUDE D'INCIDENCE-ENVOI DU DOSSIER A L'ADMINIST. COMPETENTE",
    145: "ETUDE D'INCIDENCE-ADMINISTRATION COMPETENTE-OUI POUR L'ETUDE",
    146: "ETUDE D'INCIDENCE-ADMINISTRATION COMPETENTE-NON POUR L'ETUDE",
    147: "ETUDE D'INCIDENCE-",
    149: "ETUDE D'INCIDENCE-RECEPTION DE L'AVIS DE L'ADM. COMPETENTE",
    150: "ETUDE D'INCIDENCE-",
    153: "ETUDE D'INCIDENCE-ENVOI DU DOSSIER AU COLLEGE",
    154: "ETUDE D'INCIDENCE-COLLEGE IMPOSE L'ETUDE",
    155: "ETUDE D'INCIDENCE-COLLEGE N'IMPOSE PAS L'ETUDE",
    156: "ETUDE D'INCIDENCE-DEPUTATION PERMANENTE IMPOSE L'ETUDE",
    157: "ETUDE D'INCIDENCE-REGION WALLONNE IMPOSE L'ETUDE",
    158: "ETUDE D'INCIDENCE-RECEPTION DE LA DECISION",
    159: "ETUDE D'INCIDENCE-NOTIFICATION A L'IMPETRANT",
    161: "ETUDE D'INCIDENCE-AUTEUR : RECEPTION DE SA DESIGNATION",
    162: "ETUDE D'INCIDENCE-AUTEUR : APPROBATION DU CHOIX",
    163: "ETUDE D'INCIDENCE-AUTEUR : DESAPPROBATION DU CHOIX",
    164: "ETUDE D'INCIDENCE-AUTEUR :",
    201: "ENQUETE-MISE A L'ENQUETE A LIEGE",
    202: "ENQUETE-MISE A L'ENQUETE HORS LIEGE",
    204: "ENQUETE-R.G.P.T.  2EME CLASSE",
    205: "ENQUETE-R.G.P.T.  1ERE CLASSE (RAYON DE 50 METRES)",
    206: "ENQUETE-R.G.P.T.  1ERE CLASSE (RAYON DE 100 METRES)",
    207: "ENQUETE-R.G.P.T. ENQUETE SPECIALE",
    210: "ENQUETE-ETUDE D'INCIDENCE-ENQUETE PREALABLE",
    211: "ENQUETE-ETUDE D'INCIDENCE-ENQUETE UNIQUE",
    212: "ENQUETE-ETUDE D'INCIDENCE-ENQUETE SPECIFIQUE",
    220: "ENQUETE-VISITE SUR PLACE",
    221: "ENQUETE-PREPARATION",
    225: "ENQUETE-ENVOI DES AVIS AUX PROPRIETAIRES",
    226: "ENQUETE-ENVOI DES AVIS AUX EXPLOITANTS",
    227: "ENQUETE-ENVOI DES AVIS AUX TIERS INTERESSES",
    228: "ENQUETE-ENVOI DES AVIS AUX ADMINISTRATIONS CONCERNEES",
    229: "ENQUETE-PUBLICATION DE L'AVIS DANS UN JOURNAL",
    230: "ENQUETE-AFFICHAGE ORDINAIRE-ENVOI DES AVIS",
    231: "ENQUETE-AFFICHAGE  DE L'ETUDE D'INCIDENCE-ENVOI DES AVIS",
    232: "ENQUETE-AFFICHAGE SPECIFIQUE-ENVOI DES AVIS",
    233: "ENQUETE-AFFICHAGE DES RECLAMANTS-ENVOI DES AVIS",
    234: "ENQUETE-AFFICHAGE DU RAPPORT D'INCIDENCE-ENVOI DE L'AVIS",
    235: "ENQUETE-DEBUT D'AFFICHAGE",
    236: "ENQUETE-FIN D'AFFICHAGE",
    237: "ENQUETE-AFFICHAGE-CERTIFICAT DE L'AFFICHEUR COMMUNAL",
    238: "ENQUETE-AFFICHAGE-CERTIFICAT OFFICIEL",
    239: "ENQUETE-AFFICHAGE-RETOUR DU CERTIFICAT",
    240: "ENQUETE-",
    245: "ENQUETE-PROCES-VERBAL DE CLOTURE",
    250: "ENQUETE-REUNION",
    251: "ENQUETE-REUNION-DEMANDE DE DESIGNATION DES REPRESENTANTS",
    252: "ENQUETE-REUNION-DESIGNATION DES REPRESENTANTS",
    254: "ENQUETE-REUNION-ENVOI DES CONVOCATIONS",
    255: "ENQUETE-REUNION DE CONCERTATION",
    256: "ENQUETE-REUNION-PROCES-VERBAL DE REUNION",
    257: "ENQUETE-REUNION-ENVOI DU PROCES-VERBAL",
    259: "ENQUETE-REUNION-RECEPTION DU PROCES-VERBAL",
    271: "ENQUETE-RAPPORT D'INCIDENCES SUR L'ENVIRONNEMENT",
    273: "ENQUETE-RAPPORT D'INCIDENCES-ENVOI AUX ADMINISTRATIONS",
    274: "ENQUETE-RAPPORT D'INCIDENCES-RECEPTION DU RAPPORT",
    280: "RETOUR D'ENQUETE - LIEGE",
    281: "RETOUR D'ENQUETE - HORS LIEGE",
    282: "ENQUETE DOC. MANQUANTS - RECLAMATION LIEGE",
    283: "ENQUETE DOC. MANQUANTS - RECLAMATION HORS LIEGE",
    284: "ENQUETE DOC. MANQUANTS - RAPPEL LIEGE",
    285: "ENQUETE DOC. MANQUANTS - RAPPEL HORS LIEGE",
    286: "ENQUETE DOC. MANQUANTS - RECEPTION LIEGE",
    287: "ENQUETE DOC. MANQUANTS - RECEPTION HORS LIEGE",
    290: "RESULTAT DE L'ENQUETE LIEGE - PAS DE RECLAMATIONS",
    291: "RESULTAT DE L'ENQUETE HORS LIEGE - PAS DE RECLAMATIONS",
    292: "RESULTAT DE L'ENQUETE LIEGE - RECLAMATIONS",
    293: "RESULTAT DE L'ENQUETE HORS LIEGE - RECLAMATIONS",
    300: "AUTORISATIONS DE BATIR - E.I. DEMANDENT L'AVIS DU S.A.B.",
    301: "AUTORISATIONS DE BATIR - S.A.B. DEMANDE L'AVIS DES E.I.",
    302: "AUTORISATIONS DE BATIR - E.I. : AVIS FAVORABLE",
    303: "AUTORISATIONS DE BATIR - E.I. : AVIS FAVORABLE CONDITIONNEL",
    304: "AUTORISATIONS DE BATIR - E.I. : AVIS DEFAVORABLE",
    305: "AUTORISATIONS DE BATIR - S.A.B. : AVIS FAVORABLE",
    306: "AUTORISATIONS DE BATIR - S.A.B. : AVIS FAVORABLE CONDITIONNE",
    307: "AUTORISATIONS DE BATIR - S.A.B. : AVIS DEFAVORABLE",
    308: "AUTORISATIONS DE BATIR - ENVOI DE L'AVIS DES E.I. AU S.A.B.",
    309: "AUTORISATIONS DE BATIR - RETOUR AUX E.I. DE L'AVIS DU S.A.B.",
    310: "R.W. AMEN. DU TERRITOIRE - E.I. DEMANDENT L'AVIS DE LA R.W.A",
    311: "R.W. AMEN. DU TERRITOIRE - R.W.A.T. DEMANDE L'AVIS DES E.I.",
    312: "R.W. AMEN. DU TERRITOIRE - E.I. : AVIS FAVORABLE",
    313: "R.W. AMEN. DU TERRITOIRE - E.I. : AVIS FAVORABLE CONDITIONNE",
    314: "R.W. AMEN. DU TERRITOIRE - E.I. : AVIS DEFAVORABLE",
    315: "R.W. AMEN. DU TERRITOIRE - R.W.A.T. : AVIS FAVORABLE",
    316: "R.W. AMEN. DU TERRITOIRE - R.W.A.T. : AVIS FAVORABLE CONDITI",
    317: "R.W. AMEN. DU TERRITOIRE - R.W.A.T. : AVIS DEFAVORABLE",
    318: "R.W. AMEN. DU TERRITOIRE - ENVOI DE L'AVIS DES E.I. A LA R.W",
    319: "R.W. AMEN. DU TERRITOIRE - RETOUR AUX E.I. DE L'AVIS DE LA R",
    320: "MINES-EXPLOSIFS - E.I. DEMANDENT L'AVIS DES MINES-EXPLOSIFS",
    321: "MINES-EXPLOSIFS - MINES-EXPLOSIFS DEMANDENT L'AVIS DES E.I.",
    322: "MINES-EXPLOSIFS - E.I. : AVIS FAVORABLE",
    323: "MINES-EXPLOSIFS - E.I. : AVIS FAVORABLE CONDITIONNEL",
    324: "MINES-EXPLOSIFS - E.I. : AVIS DEFAVORABLE",
    325: "MINES-EXPLOSIFS - MINES-EXPLOSIFS : AVIS FAVORABLE",
    326: "MINES-EXPLOSIFS - MINES-EXPLOSIFS : AVIS FAVORABLE CONDITION",
    327: "MINES-EXPLOSIFS - MINES-EXPLOSIFS : AVIS DEFAVORABLE",
    328: "MINES-EXPLOSIFS - ENVOI DE L'AVIS DES E.I. AUX MINES-EXPLOSI",
    329: "MINES-EXPLOSIFS - RETOUR AUX E.I. DE L'AVIS DES MINES-EXPLOS",
    330: "R.W. RES. NATURELLES - E.I. DEMANDENT L'AVIS DE LA R.W.R.N.",
    331: "R.W. RES. NATURELLES - R.W.R.N. DEMANDE L'AVIS DES E.I.",
    332: "R.W. RES. NATURELLES - E.I. : AVIS FAVORABLE",
    333: "R.W. RES. NATURELLES - E.I. : AVIS FAVORABLE CONDITIONNEL",
    334: "R.W. RES. NATURELLES - E.I. : AVIS DEFAVORABLE",
    335: "R.W. RES. NATURELLES - R.W.R.N. : AVIS FAVORABLE",
    336: "R.W. RES. NATURELLES - R.W.R.N. : AVIS FAVORABLE CONDITIONNE",
    337: "R.W. RES. NATURELLES - R.W.R.N. : AVIS DEFAVORABLE",
    338: "R.W. RES. NATURELLES - ENVOI DE L'AVIS DES E.I. A LA R.W.R.N",
    339: "R.W. RES. NATURELLES - RETOUR AUX E.I. DE L'AVIS DE LA R.W.R",
    340: "AUTRE ADMINISTRATION - E.I. DEMANDENT UN AVIS",
    341: "AUTRE ADMINISTRATION - A.ADM. DEMANDE L'AVIS DES E.I.",
    342: "AUTRE ADMINISTRATION - E.I. : AVIS FAVORABLE",
    343: "AUTRE ADMINISTRATION - E.I. : AVIS FAVORABLE CONDITIONNEL",
    344: "AUTRE ADMINISTRATION - E.I. : AVIS DEFAVORABLE",
    345: "AUTRE ADMINISTRATION - A.ADM. : AVIS FAVORABLE",
    346: "AUTRE ADMINISTRATION - A.ADM. : AVIS FAVORABLE CONDITIONNEL",
    347: "AUTRE ADMINISTRATION - A.ADM. : AVIS DEFAVORABLE",
    348: "AUTRE ADMINISTRATION - ENVOI DE L'AVIS DES E.I. A l' A.ADM.",
    349: "AUTRE ADMINISTRATION - RETOUR AUX E.I. DE L'AVIS DE L'A.ADM",
    350: "I.I.L.E. - E.I. DEMANDENT UN AVIS OU UNE VISITE DE L'I.I.L.E",
    351: "I.I.L.E. - I.I.L.E. DEMANDE L'AVIS DES E.I.",
    352: "I.I.L.E. - E.I. : AVIS FAVORABLE",
    353: "I.I.L.E. - E.I. : AVIS FAVORABLE CONDITIONNEL",
    354: "I.I.L.E. - E.I. : AVIS DEFAVORABLE",
    355: "I.I.L.E. - I.I.L.E. : AVIS FAVORABLE",
    356: "I.I.L.E. - I.I.L.E. : AVIS FAVORABLE CONDITIONNEL",
    357: "I.I.L.E. - I.I.L.E. : AVIS DEFAVORABLE",
    358: "I.I.L.E. - ENVOI DE L'AVIS DES E.I. A L' I.I.L.E.",
    359: "I.I.L.E. - RECEPTION  AUX E.I. DE L'AVIS DE L'I.I.L.E.",
    380: "REMISE DU DOSSIER APRES ENQUETE A L'INSPECTEUR",
    391: "RAPPORT DU SSSP - AVIS FAVORABLE COMPLET TEMPORAIRE",
    392: "RAPPORT DU SSSP - AVIS FAVORABLE PARTIEL TEMPORAIRE",
    393: "RAPPORT DU SSSP - AVIS FAVORABLE COMPLET DEFINITIF",
    394: "RAPPORT DU SSSP - AVIS FAVORABLE PARTIEL DEFINITIF",
    395: "RAPPORT DU SSSP - AVIS DEFAVORABLE",
    400: "ENVOI DU DOSSIER AU COLLEGE",
    401: "DOSSIER RETOURNE PAR BGM  POUR MISE AU POINT",
    405: "ATTESTATION DE SECURITE FAVORABLE",
    406: "ATTESTATION DE SECURITE FAVORABLE CONDITIONNELLE",
    407: "ATTESTATION DE SECURITE DEFAVORABLE",
    410: "COLLEGE - AJOURNE",
    411: "COLLEGE - AVIS FAVORABLE COMPLET TEMPORAIRE",
    412: "COLLEGE - AVIS FAVORABLE PARTIEL TEMPORAIRE",
    413: "COLLEGE - AVIS FAVORABLE COMPLET DEFINITIF",
    414: "COLLEGE - AVIS FAVORABLE PARTIEL DEFINITIF",
    415: "COLLEGE - AVIS DEFAVORABLE",
    421: "COLLEGE - AUTORISATION COMPLETE TEMPORAIRE",
    422: "COLLEGE - AUTORISATION PARTIELLE TEMPORAIRE",
    423: "COLLEGE - AUTORISATION COMPLETE DEFINITIVE",
    424: "COLLEGE - AUTORISATION PARTIELLE DEFINITIVE",
    425: "COLLEGE - REFUS",
    426: "COLLEGE - AUTORISATION COMPLEMENTAIRE",
    429: "RETOUR DU DOSSIER DU COLLEGE",
    430: "ENVOI DE L'AVIS DU COLLEGE A LA D.P.",
    431: "D.P. - AUTORISATION COMPLETE TEMPORAIRE",
    432: "D.P. - AUTORISATION PARTIELLE TEMPORAIRE",
    433: "D.P. - AUTORISATION COMPLETE DEFINITIVE",
    434: "D.P. - AUTORISATION PARTIELLE DEFINITIVE",
    435: "D.P. - REFUS",
    436: "D.P. - AUTORISATION COMPLEMENTAIRE",
    437: "D.P. - ABANDON DU PROJET",
    439: "RECEPTION DE LA DECISION DE LA D.P.",
    440: "ENVOI DE L'AVIS DU COLLEGE AU MINISTRE",
    441: "R.W. - AUTORISATION COMPLETE TEMPORAIRE",
    442: "R.W. - AUTORISATION PARTIELLE TEMPORAIRE",
    443: "R.W. - AUTORISATION COMPLETE DEFINITIVE",
    444: "R.W. - AUTORISATION PARTIELLE DEFINITIVE",
    445: "R.W. - REFUS",
    446: "R.W. - AUTORISATION COMPLEMENTAIRE",
    447: "R.W. - ABANDON DU PROJET",
    448: "R.W./AUTORISATION",
    449: "RECEPTION DE LA DECISION DE LA R.W.",
    460: "AFFICHAGE DE LA DECISION - ENVOI DES AVIS",
    462: "AFFICHAGE DE LA DECISION - DEBUT D'AFFICHAGE",
    463: "AFFICHAGE DE LA DECISION - FIN D'AFFICHAGE",
    466: "AFFICHAGE DE LA DECISION - CERTIFICAT DE L'AFFICHEUR",
    467: "AFFICHAGE DE LA DECISION - CERTIFICAT DU BOURGMESTRE",
    468: "AFFICHAGE DE LA DECISION-RETOUR DU CERTIFICAT DU BOURGMESTRE",
    469: "AFFICHAGE DE LA DECISION - RETOUR DU CERTIFICAT DE L'AFFICHE",
    470: "NOTIFICATION DE LA DECISION - ENVOI DES DOCUMENTS",
    471: "NOTIFICATION DE LA DECISION - CONVOCATION DE L'IMPETRANT",
    472: "NOTIFICATION DE LA DECISION - REMISE DES DOCUMENTS",
    479: "NOTIFICATION DE LA DECISION - RETOUR DU CERTIFICAT",
    490: "ENVOI A LA D.P. DES CERT. D'AFFICHAGE ET DE NOTIFICATION",
    501: "RECOURS - RECEPTION DU DOSSIER DE LA D.P.",
    510: "RECOURS - AFFICHAGE - ENVOI DES AVIS",
    512: "RECOURS - DEBUT D'AFFICHAGE",
    513: "RECOURS - FIN D'AFFICHAGE",
    516: "RECOURS - AFFICHAGE - CERTIFICAT DE L'AFFICHEUR",
    517: "RECOURS - AFFICHAGE - CERTIFICAT DU BOURGMESTRE",
    518: "RECOURS - AFFICHAGE - RETOUR DU CERTIFICAT DU BOURGMESTRE",
    519: "RECOURS - AFFICHAGE - RETOUR DU CERTIFICAT DE L'AFFICHEUR",
    520: "RECOURS - NOTIFICATION A L'EXPLOITANT - ENVOI DES DOC.",
    521: "RECOURS-NOTIFICATION A L'EXPLOITANT-CONVOCATION DE L'IMPETRA",
    522: "RECOURS - NOTIFICATION A L'EXPLOITANT - REMISE DES DOC.",
    529: "RECOURS - NOTIFICATION A L'EXPLOITANT - RETOUR DU CERT.",
    530: "RECOURS - ENVOI DES DOCUMENTS UTILES A LA D.P.",
    531: "D.P. SUR RECOURS - AUTORISATION COMPLETE TEMPORAIRE",
    532: "D.P. SUR RECOURS - AUTORISATION PARTIELLE TEMPORAIRE",
    533: "D.P. SUR RECOURS - AUTORISATION COMPLETE DEFINITIVE",
    534: "D.P. SUR RECOURS - AUTORISATION PARTIELLE DEFINITIVE",
    535: "D.P. SUR RECOURS - REFUS",
    536: "D.P. SUR RECOURS - AUTORISATION COMPLEMENTAIRE",
    537: "D.P. SUR RECOURS - ABANDON DU PROJET",
    538: "D.P. SUR RECOURS -",
    539: "RECEPTION DE LA DECISION SUR RECOURS DE LA D.P.",
    540: "RECOURS - ENVOI DES DOCUMENTS UTILES A LA R.W.",
    541: "R.W. SUR RECOURS - AUTORISATION COMPLETE TEMPORAIRE",
    542: "R.W. SUR RECOURS - AUTORISATION PARTIELLE TEMPORAIRE",
    543: "R.W. SUR RECOURS - AUTORISATION COMPLETE DEFINITIVE",
    544: "R.W. SUR RECOURS - AUTORISATION PARTIELLE DEFINITIVE",
    545: "R.W. SUR RECOURS - REFUS",
    546: "R.W. SUR RECOURS - AUTORISATION COMPLEMENTAIRE",
    547: "R.W. SUR RECOURS - ABANDON DU PROJET",
    548: "R.W.SUR RECOURS -",
    549: "RECEPTION DE LA DECISION SUR RECOURS DE LA R.W.",
    560: "AFFICHAGE DE LA DECISION SUR RECOURS - ENVOI DES AVIS",
    562: "AFFICHAGE DE LA DECISION SUR RECOURS - DEBUT D'AFFICHAGE",
    563: "AFFICHAGE DE LA DECISION SUR RECOURS - FIN D'AFFICHAGE",
    566: "AFFICHAGE DE LA DECISION SUR RECOURS - CERTIF. DE L'AFFICHEU",
    567: "AFFICHAGE DE LA DECISION S/RECOURS - CERTIF. DU BOURGMESTRE",
    568: "AFFICHAGE DE LA DECISION S/RECOURS-RETOUR CERT. BOURGMESTRE",
    569: "AFFICHAGE DE LA DECISION SUR RECOURS - RETOUR CERT. AFFICHEU",
    570: "NOTIFICATION DE LA DECISION SUR RECOURS - ENVOI DES DOC.",
    571: "NOTIFICATION DECISION SUR RECOURS-CONVOCATION DES INTERESSES",
    572: "NOTIFICATION DECISION SUR RECOURS - REMISE A L'IMPETRANT",
    573: "NOTIFICATION DECISION SUR RECOURS - REMISE AU TIERS",
    578: "",
    579: "NOTIFICATION DECISION SUR RECOURS - RETOUR DES CERTIFICATS",
    580: "ENVOI A LA D.P. DES CERTIFICATS D'AFFICHAGE ET DE NOTIFICATI",
    600: "CONSEIL D'ETAT",
    700: "DEMANDE DE RENSEIGNEMENTS/DOCUMENTS PAR L'IMPETRANT",
    701: "DEMANDE DE RENSEIGNEMENTS/DOCUMENTS PAR LE BOURGMESTRE",
    702: "DEMANDE DE RENSEIGNEMENTS/DOCUMENTS PAR UN ECHEVIN",
    703: "DEMANDE DE RENSEIGNEMENTS/DOCUMENTS PAR UN CONSEILLER CL",
    704: "DEMANDE DE RENSEIGNEMENTS/DOCUMENTS PAR LE DIRECTEUR",
    705: "DEMANDE DE RENSEIGNEMENTS/DOCUMENTS PAR LE DEP. JURIDIQUE",
    707: "DEMANDE DE RENSEIGNEMENTS/DOCUMENTS PAR UNE ADM. PUBLIQUE",
    708: "DEMANDE DE RENSEIGNEMENTS/DOCUMENTS PAR UN TIERS",
    710: "PLAINTES HORS ENQUETE PARVENUES DIRECTEMENT",
    711: "PLAINTES HORS ENQUETE VIA LE BOURGMESTRE",
    712: "PLAINTES HORS ENQUETE VIA UN ECHEVIN",
    713: "PLAINTES HORS ENQUETE PARVENUES INDIRECTEMENT",
    717: "",
    720: "VISITE SUR PLACE DE L'INSPECTEUR DES E.I.",
    721: "VISITE SUR PLACE DE L' I.I.L.E.",
    722: "VISITE SUR PLACE DU FONCTIONNAIRE TECHNIQUE COMPETENT",
    725: "VISITE SUR PLACE D' AUTRES PERSONNES",
    730: "VISITE PROGRAMMEE DE L'INSPECTEUR DES E.I.",
    731: "VISITE PROGRAMMEE DE L' I.I.L.E.",
    732: "VISITE PROGRAMMEE DU FONCTIONNAIRE TECHNIQUE COMPETENT",
    735: "VISITE PROGRAMMEE D' AUTRES PERSONNES",
    740: "RAPPORT CIRCONSTANCIE DES E.I.",
    745: "RAPPORT SUR POLLUTIONS DES E.I.",
    750: "RAPPORT CIRCONSTANCIE DU FONCTIONNAIRE TECHNIQUE COMPETENT",
    755: "RAPPORT SUR POLLUTIONS DU FONCTIONNAIRE TECHNIQUE COMPETENT",
    771: "ENVOI DE DOCUMENTS AU PROPRIETAIRE",
    772: "ENVOI DE DOCUMENTS A L'EXPLOITANT",
    773: "ENVOI DE DOCUMENTS AU BOURGMESTRE",
    774: "ENVOI DE DOCUMENTS A UN ECHEVIN",
    775: "ENVOI DE DOCUMENTS A UN CONSEILLER COMMUNAL",
    777: "ENVOI DE DOCUMENTS A L'ADMINISTRATION PUBLIQUE",
    778: "ENVOI DE DOCUMENTS A UN TIERS",
    781: "PRESCRIPTIONS DE L' I.I.L.E.",
    782: "PRESCRIPTIONS DES E.I.",
    785: "PRESCRIPTIONS - NOTIFICATION A L'IMPETRANT",
    786: "PRESCRIPTIONS - RAPPEL A L'IMPETRANT",
    787: "PRESCRIPTIONS - CONVOCATION DE L'IMPETRANT",
    788: "PRESCRIPTIONS - MESURES AVANT FERMETURE",
    800: "FIN FORCEE PAR L'EXPLOITANT POUR UNE CAUSE INDETERMINEE",
    801: "ABANDON DU PROJET",
    802: "DEPOT D'UNE AUTRE DEMANDE D'EXPLOITER",
    803: "NON EXPLOITATION DANS LES DELAIS IMPARTIS",
    810: "CESSATION POUR UNE CAUSE INDETERMINEE",
    811: "CESSATION PAR PENSION",
    812: "CESSATION PERSONNELLE AUTRE QUE LA PENSION",
    819: "DECES DE L'EXPLOITANT",
    820: "CESSION A UN AUTRE EXPLOITANT",
    831: "FAILLITE",
    851: "DESTRUCTION ACCIDENTELLE DE L'ETABLISSEMENT",
    900: "DOSSIER CLASSE AUX ARCHIVES",
    901: "DOSSIER CLASSE SANS SUITE",
    902: "DOSSIER REPRIS SOUS UN AUTRE NUMERO",
    905: "AUTORISATION NON ACCORDEE",
    906: "AUTORISATION NON RENOUVELEE",
    909: "Classement aux archives du Service",
    910: "DOSSIER REMIS A L'INSPECTEUR",
    911: "DOSSIER REMIS A L'INSPECTEUR EN CHEF",
    912: "DOSSIER REMIS AU CHEF ADMINISTRATIF",
    915: "DOSSIER REMIS A LA DIRECTION",
    916: "DOSSIER REMIS AU CABINET DU BOURGMESTRE",
    919: "RETOUR DU DOSSIER",
    920: "FIN FORCEE PAR L'ADMINISTRATION POUR UNE CAUSE INDETERMINEE",
    931: "RETRAIT OU SUSPENSION TOTAL TEMPORAIRE DE L'AUTORISATION",
    932: "RETRAIT OU SUSPENSION PARTIEL TEMPORAIRE DE L'AUTORISATION",
    933: "RETRAIT OU SUSPENSION TOTAL DEFINITIF DE L'AUTORISATION",
    934: "RETRAIT OU SUSPENSION PARTIEL DEFINITIF DE L'AUTORISATION",
    936: "LEVEE TOTALE DU RETRAIT/SUSPENSION DE L'AUTORISATION",
    937: "LEVEE PARTIELLE DU RETRAIT/SUSPENSION DE L'AUTORISATION",
    941: "FERMETURE TOTALE TEMPORAIRE",
    942: "FERMETURE PARTIELLE TEMPORAIRE",
    943: "FERMETURE TOTALE DEFINITIVE",
    944: "FERMETURE PARTIELLE DEFINITIVE",
    946: "LEVEE TOTALE DE LA FERMETURE",
    947: "LEVEE PARTIELLE DE LA FERMETURE",
    995: "",
    996: "",
    997: "FIN FORCEE ANTERIEURE A L'ANNEE CONCERNEE",
    999: "ERREUR A SUPPRIMER",
    1010: "PROVOCATION-DEMANDE ET/OU VISITE DE L'INSPECTEUR",
    1020: "PROVOCATION-LETTRE DE LA DPC A L'EXPLOITANT",
    1030: "PROVOCATION-ENVOI DU FORMULAIRE DE DEMANDE A L'EXPLOITANT",
    1040: "PROVOCATION-REMISE DU FORMULAIRE DE DEMANDE A L'EXPLOITANT",
    1050: "PROVOCATION-RAPPEL A L'EXPLOITANT",
    1060: "PROVOCATION-LETTRE A L'EXPLOITANT",
    1080: "PROVOCATION",
    1100: "DEPOT DU DOSSIER PAR RECOMMANDE AVEC TAXE VILLE",
    1110: "DEPOT DU DOSSIER PAR RECOMMANDE SANS TAXE VILLE",
    1120: "DEPOT DU DOSSIER CONTRE ACCUSE DE RECEPTION AVEC TAXE VILLE",
    1130: "DEPOT DU DOSSIER CONTRE ACCUSE DE RECEPTION SANS TAXE VILLE",
    1140: "DEPOT IRREGULIER DU DOSSIER",
    1150: "DEPOT IRREGULIER DU DOSSIER-RENVOI DU DOSSIER A L'EXPLOITANT",
    1180: "DEPOT DU DOSSIER",
    1200: "EXPLOITANT-INFORMATION DE L'ENVOI DU DOSSIER A LA DPA",
    1210: "EXPLOITANT-RECLAMATION PLANS SUPPLEMENTAIRES POUR P.U.",
    1219: "EXPLOITANT-RECEPTION DES PLANS SUPPLEMENTAIRES RECLAMES",
    1220: "EXPLOITANT-RECLAMATION DE DIVERS DOCUMENTS/RENSEIGNEMENTS",
    1229: "EXPLOITANT-RECEPTION DOCUMENTS/RENSEIGNEMENTS RECLAMES",
    1280: "EXPLOITANT",
    1300: "FRAIS DE DOSSIER-RECLAMATION A L'EXPLOITANT",
    1310: "FRAIS DE DOSSIER-1ER RAPPEL A L'EXPLOITANT",
    1319: "FRAIS DE DOSSIER-RECEPTION PREUVE DE PAYEMENT",
    1320: "FRAIS DE DOSSIER-DROIT CONSTATE POUR LE RECEVEUR COMMUNAL",
    1330: "FRAIS DE DOSSIER-DEMANDE DE REMBOURSEMENT A L'EXPLOITANT",
    1340: "FRAIS DE DOSSIER-ENCODAGE DE LA REDEVANCE",
    1350: "FRAIS DE DOSSIER-LETTRE D'INFORMATION-REDEVANCE",
    1380: "FRAIS DE DOSSIER",
    1400: "1ER AVIS TECHNIQUE-DEMANDE D'AVIS AU CABINET DU BGM",
    1409: "1ER AVIS TECHNIQUE-RETOUR DE L'AVIS DU CABINET DU BGM",
    1410: "1ER AVIS TECHNIQUE-CABINET BGM-AUCUNE REMARQUE",
    1420: "1ER AVIS TECHNIQUE-CABINET BGM-SUIVRE ATTENTIVEMENT",
    1430: "1ER AVIS TECHNIQUE-CABINET BGM-SUIVI POSITIVEMENT",
    1440: "1ER AVIS TECHNIQUE-CABINET BGM-SUIVI AVEC RESERVES",
    1480: "1ER AVIS TECHNIQUE",
    1500: "SAB-ENVOI DE LA DEMANDE POUR AVIS SUR P.E.",
    1509: "SAB-RETOUR DE L'AVIS SUR PERMIS D'ENVIRONNEMENT",
    1510: "SAB-AVIS FAVORABLE SUR PERMIS D'ENVIRONNEMENT",
    1520: "SAB-AVIS FAVORABLE CONDITIONNEL SUR PERMIS D'ENVIRONNEMENT",
    1530: "SAB-AVIS DEFAVORABLE SUR PERMIS D'ENVIRONNEMENT",
    1580: "SAB",
    1600: "SAB-EDII DEMANDE AVIS SUR P.U. ET DESIGNATION DU GESTIONNAIR",
    1601: "SAB-ENVOI DOCUMENTS COMPLEMENTAIRES RECLAMES PAR DPA+B612",
    1602: "SAB-EDII  EST GESTIONNAIRE DU DOSSIER",
    1603: "SAB-URBANISME EST GESTIONNAIRE DU DOSSIER",
    1609: "SAB-RETOUR DE L'AVIS SUR PERMIS UNIQUE",
    1610: "SAB-AVIS FAVORABLE SUR PERMIS UNIQUE",
    1620: "SAB-AVIS FAVORABLE CONDITIONNEL SUR PERMIS UNIQUE",
    1630: "SAB-AVIS DEFAVORABLE SUR PERMIS UNIQUE",
    1680: "SAB-PERMIS UNIQUE",
    1700: "SAB-DEMANDE L'AVIS DU SEDII SUR PERMIS DE BATIR",
    1709: "SAB-ENVOI DE L'AVIS DU SEDII SUR PERMIS DE BATIR",
    1710: "SAB-AVIS FAVORABLE DU SEDII SUR PERMIS DE BATIR",
    1720: "SAB-AVIS FAVORABLE CONDITIONNEL DU SEDII SUR PERMIS DE BATIR",
    1730: "SAB-AVIS DEFAVORABLE DU SEDII SUR PERMIS DE BATIR",
    1780: "SAB-PERMIS DE BATIR",
    1800: "RECEVABILITE-ENVOI DU DOSSIER POUR AVIS A LA DPA/DGATLPE",
    1801: "RECEVABILITE-RECEPTION DU DOSSIER A LA DPA/DGATLPE",
    1809: "RECEVABILITE-RETOUR DE L'AVIS DE LA DPA/DGATLPE",
    1810: "RECEVABILITE-DPA/DGATLPE-DOSSIER COMPLET ET RECEVABLE",
    1811: "RECEVABILITE-COLLEGE COMMUNAL EST L'AUTORITE COMPETENTE",
    1812: "RECEVABILITE-F.T. EST L'AUTORITE COMPETENTE",
    1813: "RECEVABILITE-AUTRE COMMUNE EST L'AUTORITE COMPETENTE",
    1819: "RECEVABILITE-RETOUR HORS DELAI DE L'AVIS DE LA DPA/DGATLPE",
    1820: "RECEVABILITE-DPA/DGATLPE-DOSSIER INCOMPLET",
    1821: "RECEVABILITE-DOSSIER INCOMPLET DE LONGUE DUREE-LETTRE A  DPA",
    1830: "RECEVABILITE-DPA/DGATLPE-DOSSIER IRRECEVABLE",
    1840: "RECEVABILITE-DPA/DGATLPE-DEMANDE SANS OBJET",
    1850: "RECEVABILITE-ENVOI AVIS DE LA DPA/DGATLPE AU SAB",
    1860: "RECEVABILITE-RECU DE L'EXPL. DOCUMENTS RECLAMES PAR DPA",
    1861: "RECEVABILITE-ENVOI DOCUMENTS RECLAMES A LA DPA/DGATLPE",
    1862: "RECEVABILITE-INFO A EXPLOITANT-DATE DE RECEP. DOSSIER A DPA",
    1870: "RECEVABILITE-DPA DEMANDE AU DEMANDEUR PLANS MODIF-ART.93.3",
    1871: "RECEVABILITE-RECU DE L EXPLOITANT PLANS MODIFICATIFS-ART.93.",
    1880: "RECEVABILITE",
    1900: "RUBRIQUES",
    2000: "ENQUETE-DOSSIER TRANSMIS POUR ENQUETE A LIEGE",
    2009: "ENQUETE-RETOUR DU DOSSIER APRES ENQUETE A LIEGE",
    2010: "ENQUETE-DOSSIER TRANSMIS POUR ENQUETE HORS LIEGE",
    2019: "ENQUETE-RETOUR DU DOSSIER APRES ENQUETE HORS LIEGE",
    2020: "ENQUETE-RGPE - 2EME CLASSE",
    2030: "ENQUETE-RGPE - 1ERE CLASSE",
    2040: "ENQUETE-SPECIFIQUE",
    2050: "ENQUETE-ENVOI DES DOCUMENTS POUR REPERAGE",
    2051: "ENQUETE-REPERAGE SUR SITE",
    2060: "ENQUETE-ENVOI DES AVIS AUX PROPRIETAIRES",
    2070: "ENQUETE-ENVOI DES AVIS AUX EXPLOITANTS",
    2080: "ENQUETE-ENVOI DES AVIS AUX TIERS INTERESSES",
    2090: "ENQUETE-ENVOI DES AVIS AUX ADMINISTRATIONS CONCERNEES",
    2100: "ENQUETE-PUBLICATION DE L'AVIS DANS 3 JOURNAUX",
    2101: "ENQUETE-ENVOI A EXPLOITANT AVIS A PUBLIER DANS LES JOURNAUX",
    2110: "ENQUETE-AFFICHAGE ORDINAIRE-ENVOI DES AVIS",
    2119: "ENQUETE-RETOUR DU CERTIFICAT D'AFFICHAGE ORDINAIRE",
    2120: "ENQUETE-AFFICHAGE SPECIFIQUE-ENVOI DES AVIS",
    2129: "ENQUETE-RETOUR DU CERTIFICAT D'AFFICHAGE SPECIFIQUE",
    2130: "ENQUETE-DEBUT D'AFFICHAGE",
    2140: "ENQUETE-FIN D'AFFICHAGE",
    2150: "ENQUETE-RECEPTION D'UNE PLAINTE",
    2160: "ENQUETE-PROCES VERBAL DE CLOTURE",
    2180: "ENQUETE",
    2200: "ENQUETE-FT DONNE AVERTISSEMENT ET FIXE LES DELAIS D'ENQUETE",
    2210: "ENQUETE-FONCTIONNAIRE TECHNIQUE REALISE L'ENQUETE PUBLIQUE",
    2220: "ENQUETE-DOSSIER TRANSMIS POUR ENQUETE FORCEE",
    2229: "ENQUETE-RETOUR DU DOSSIER APRES ENQUETE FORCEE",
    2230: "ENQUETE-MISE A L'ENQUETE FORCEE-INFORMATION A LA DPA",
    2240: "ENQUETE-MISE A L'ENQUETE FORCEE-INFORMATION A LA DGATLPE",
    2250: "ENQUETE-ENVOI PV D'ENQUETE A LA SIGNATURE DU COLLEGE",
    2259: "ENQUETE-RETOUR PV D'ENQUETE SIGNE PAR LE COLLEGE",
    2260: "ENQUETE-PV DE CLOTURE D'ENQUETE TRANSMIS AU SAB",
    2270: "ENQUETE-PLAINTES TRANSMISES AU SAB",
    2280: "ENQUETE",
    2300: "RESULTAT DE L'ENQUETE - RECLAMATIONS LIEGE",
    2310: "RESULTAT DE L'ENQUETE - RECLAMATIONS HORS LIEGE",
    2320: "RESULTAT DE L'ENQUETE - PAS DE RECLAMATION LIEGE",
    2330: "RESULTAT DE L'ENQUETE - PAS DE RECLAMATION HORS LIEGE",
    2380: "RESULTAT DE L'ENQUETE",
    2400: "REUNION DE CONCERTATION DEMANDEE PAR LE FT",
    2410: "REUNION DE CONCERTATION DEMANDEE PAR L'AUTORITE COMPETENTE",
    2420: "REUNION DE CONCERTATION DEMANDEE PAR INSTANCE D'AVIS",
    2430: "REUNION DE CONCERTATION DEMANDEE PAR LE BOURGMESTRE",
    2440: "REUNION DE CONCERTATION DEMANDEE PAR LES RIVERAINS",
    2450: "REUNION DE CONCERTATION-ENVOI DU DOSSIER POUR CONVOCATION",
    2459: "REUNION DE CONCERTATION-RETOUR DU DOSSIER",
    2460: "REUNION DE CONCERTATION-DATE DE LA REUNION",
    2470: "REUNION DE CONCERTATION-ENVOI DES CONVOCATIONS",
    2480: "REUNION DE CONCERT. AVEC RIVERAINS-PROJET PV TRANSMIS BGM",
    2489: "REUNION DE CONCERT. AVEC RIVERAINS-RETOUR PV DU BGM",
    2490: "REUNION DE CONCERTATION-RECEPTION DU PROCES VERBAL",
    2491: "REUNION DE CONCERTATION",
    2500: "ARTICLE 29-ENVOI AU COLLEGE-AVIS DESTINE A LA DPA",
    2509: "ARTICLE 29-RETOUR DU DOSSIER COLLEGE-AVIS DESTINE A LA DPA",
    2510: "ARTICLE 29-COLLEGE-AVIS FAVORABLE DESTINE A LA DPA",
    2520: "ARTICLE 29-COLLEGE-AVIS FAVORABLE COND. DESTINE A LA DPA",
    2530: "ARTICLE 29-COLLEGE-AVIS DEFAVORABLE DESTINE A LA DPA",
    2540: "ARTICLE 29-COLLEGE-ABSENCE D'AVIS",
    2580: "ARTICLE 29",
    2600: "ARTICLE 91-DEMANDE D'AVIS DU FT DE LA DPA",
    2609: "ARTICLE 91-AVIS DU COLLEGE TRANSMIS A LA DPA",
    2610: "ARTICLE 91-ENVOI AU COLLEGE-AVIS DESTINE A LA DPA",
    2619: "ARTICLE 91-RETOUR DU DOSSIER COLLEGE-AVIS DESTNE A LA DPA",
    2620: "ARTICLE 91-COLLEGE-AVIS FAVORABLE DESTINE A LA DPA",
    2630: "ARTICLE 91-COLLEGE-AVIS FAVORABLE COND. DESTINE A LA DPA",
    2640: "ARTICLE 91-COLLEGE-AVIS DEFAVORABLE DESTINE A LA DPA",
    2680: "ARTICLE 91",
    2700: "RAPPORT DE SYNTHESE-ENVOI A LA DPA/DGATLPE",
    2709: "RAPPORT DE SYNTHESE-RECEPTION DU PROJET DE LA DPA/DGATLPE",
    2720: "RON PROJET DE LA DPA/DGATLPE",
    2730: "RAPPORT DE SYNTHESE-PROJET HORS DELAI DE LA DPA/DGATLPE",
    2740: "RAPPORT DE SYNTHESE-DPA/DGATLPE-DELAI SUPPL. DE 30 JOURS",
    2750: "RAPPORT DE SYNTHESE-ENVOI PROJET D'ARRETE AU SAB",
    2759: "RAPPORT DE SYNTHESE-RECU AVIS SUR PROJET D'ARRETE DU SAB",
    2780: "RAPPORT DE SYNTHESE",
    2800: "ETABLISSEMENT SITUE SUR PLUSIEURS COMMUNES",
    2810: "RAPPORT DE SYNTHESE TRANSMIS A LA DPA-PLUSIEURS COMMUNES",
    2819: "DPA-RECEPTION DECISION-ETABL. SUR PLUSIEURS COMMUNES",
    2820: "RAPPORT DE SYNTHESE TRANSMIS A DGATLPE-PLUSIEURS COMMUNES",
    2829: "DGATLPE-RECEPTION DECISION-ETABL. SUR PLUSIEURS COMMUNES",
    2900: "DPA/DGTALPE-AUTORISATION COMPLETE",
    2910: "DPA/DGTALPE-AUTORISATION PARTIELLE",
    2920: "DPA/DGTALPE-AUTORISATION TEMPORAIRE",
    2930: "DPA/DGTALPE-AUTORISATION A L'ESSAI",
    2940: "DPA/DGTALPE-AUTORISATION COMPLEMENTAIRE",
    2950: "DPA/DGTALPE-REFUS",
    2980: "DPA/DGTALPE",
    3000: "COLLEGE-ENVOI DU DOSSIER AU COLLEGE",
    3009: "COLLEGE-RETOUR DU DOSSIER",
    3010: "COLLEGE-DOSSIER RETOURNE PAR BGM POUR MISE AU POINT",
    3020: "COLLEGE-AJOURNE",
    3030: "COLLEGE-AUTORISATION COMPLETE",
    3040: "COLLEGE-AUTORISATION PARTIELLE",
    3050: "COLLEGE-AUTORISATION TEMPORAIRE",
    3060: "COLLEGE-AUTORISATION A L'ESSAI",
    3070: "COLLEGE-AUTORISATION COMPLEMENTAIRE",
    3071: "COLLEGE-MODIFICATION AUTORISATION EXISTANTE",
    3080: "COLLEGE",
    3090: "COLLEGE-REFUS",
    3100: "COLLEGE-MODIFICATIONS MINIMES",
    3200: "AFCN-RECEPTION DE LA DECISION",
    3210: "AFCN-AUTORISATION COMPLETE",
    3220: "AFCN-AUTORISATION PARTIELLE",
    3230: "AFCN-AUTORISATION TEMPORAIRE",
    3240: "AFCN-AUTORISATION COMPLEMENTAIRE",
    3250: "AFCN-REFUS",
    3260: "AFCN-RECU CERTIFICAT D'INSTALLATION D'UN ORGANISME AGREE",
    3270: "AFCN-CERTIFICAT D'INSTALLATION TRANSMIS A AFCN",
    3280: "AFCN",
    3300: "AUTORISATION TACITE SUR BASE DU RAPPORT DU F.T. DU SPW",
    3310: "AUTORISATION TACITE-NOTIFICATION AU DEMANDEUR",
    3320: "AUTORISATION TACITE-LETTRE A LA DPA/DGATLPE",
    3400: "REFUS TACITE",
    3410: "REFUS TACITE-NOTIFICATION AU DEMANDEUR",
    3420: "REFUS TACITE-LETTRE A LA DPA/DGATLPE",
    3500: "RECEPTION DECISION",
    3510: "RECEPTION D UNE DECISION PAR UNE AUTRE COMMUNE",
    3511: "AUTRE COMMUNE-AUTORISATION COMPLETE",
    3512: "AUTRE COMMUNE-AUTORISATION PARTIELLE",
    3513: "AUTRE COMMUNE-AUTORISATION TEMPORAIRE",
    3514: "AUTRE COMMUNE-AUTORISATION A L'ESSAI",
    3515: "AUTRE COMMUNE-AUTORISATION COMPLEMENTAIRE",
    3516: "AUTRE COMMUNE-MODIFICATION AUTORISATION EXISTANTE",
    3517: "AUTRE COMMUNE-REFUS",
    3519: "AUTRE COMMUNE-",
    3600: "DECISION-NOTIFICATION PAR RECOMMANDE AU DEMANDEUR",
    3610: "DECISION-NOTIFICATION DE LA DECISION TIMBREE AU DEMANDEUR",
    3620: "DECISION-ENVOI COPIE AU FONCTIONNAIRE TECHNIQUE DE LA DPA",
    3630: "DECISION-ENVOI COPIE AU FONCTIONNAIRE DELEGUE DE LA DGATLPE",
    3640: "DECISION-ENVOI EXTRAIT ARRETE + PLAN A LA CELLULE COMMODO",
    3650: "DECISION-ENVOI ARRETE POUR AMPLIATION + PLANS A LA SIGNATURE",
    3659: "DECISION-RETOUR ARRETE + PLANS SIGNES",
    3660: "DECISION-ENVOI COPIE AUX INSTANCES CONSULTEES",
    3670: "DECISION-RETOUR DU PLAN SIGNE DE LA CELLULE COMMODO",
    3680: "DECISION",
    3700: "DECISION-AFFICHAGE-ENVOI DES AVIS A L'AFFICHEUR",
    3709: "DECISION-AFFICHAGE-RETOUR CERTIFICAT DE L'AFFICHEUR",
    3710: "DECISION-DEBUT D'AFFICHAGE",
    3720: "DECISION-FIN D'AFFICHAGE",
    3730: "DECISION-ENVOI CERTIFICAT D'AFFICHAGE A SIGNER PAR BGM",
    3739: "DECISION-RETOUR CERTIFICAT D'AFFICHAGE SIGNE PAR BGM",
    3780: "DECISION-AFFICHAGE",
    4000: "RECOURS-RECEPTION DU SPW",
    4009: "RECOURS-ENVOI DES DOCUMENTS DEMANDES AU SPW",
    4010: "RECOURS INTRODUIT PAR LE DEMANDEUR",
    4020: "RECOURS INTRODUIT PAR LE FONCTIONNAIRE TECHNIQUE",
    4030: "RECOURS INTRODUIT PAR LA VILLE",
    4040: "RECOURS INTRODUIT PAR UN TIERS",
    4080: "RECOURS",
    4100: "RECOURS-ENVOI A LA CELLULE COMMODO POUR AFF. ET/OU NOT.",
    4109: "RECOURS-RETOUR DE LA CELLULE COMMODO APRES AFF. ET/OU NOTIF.",
    4110: "RECOURS-ENVOI DES AVIS A L'AFFICHEUR",
    4119: "RECOURS-RETOUR DU CERTIFICAT DE L'AFFICHEUR",
    4120: "RECOURS-DEBUT D'AFFICHAGE",
    4130: "RECOURS-FIN D'AFFICHAGE",
    4140: "RECOURS-ENVOI DU CERTIFICAT D'AFFICHAGE A SIGNER PAR BGM",
    4149: "RECOURS-RETOUR CERTIFICAT AFFICHAGE SIGNE PAR BGM",
    4150: "RECOURS-NOTIFICATION AU DEMANDEUR ET/OU AU TIERS",
    4160: "RECOURS-TRANSMIS COPIE AU SAB",
    4170: "RECOURS-ENVOI CERTIFICAT D'AFFICHAGE AU SPW",
    4200: "DECISION SUR RECOURS-RECEPTION DU SPW",
    4210: "DECISION SUR RECOURS-AUTORISATION COMPLETE",
    4220: "DECISION SUR RECOURS-AUTORISATION PARTIELLE",
    4230: "DECISION SUR RECOURS-AUTORISATION TEMPORAIRE",
    4240: "DECISION SUR RECOURS-AUTORISATION COMPLEMENTAIRE",
    4250: "DECISION SUR RECOURS-ANNULATION DE LA DECISION DU COLLEGE",
    4260: "DECISION SUR RECOURS-REFUS",
    4270: "DECISION SUR RECOURS-RECEVABLE MAIS SANS OBJET",
    4280: "DECISION SUR RECOURS",
    4300: "DECISION SUR RECOURS-ENVOI A CELL. COMM. POUR AFF.ET/OU NOT.",
    4309: "DECISION SUR RECOURS-RETOUR CELL. COMM. APRES AFF.ET/OU NOT.",
    4310: "DECISION SUR RECOURS-ENVOI DES AVIS A L'AFFICHEUR",
    4319: "DECISION SUR RECOURS-RETOUR DU CERTIFICAT DE L'AFFICHEUR",
    4320: "DECISION SUR RECOURS-DEBUT D'AFFICHAGE",
    4330: "DECISION SUR RECOURS-FIN D'AFFICHAGE",
    4340: "DECISION SUR RECOURS-ENVOI CERT. AFFICHAGE A SIGNER PAR BGM",
    4349: "DECISION SUR RECOURS-RETOUR CERT. AFFICHAGE SIGNE PAR BGM",
    4350: "DECISION SUR RECOURS-NOTIF. AU DEMANDEUR ET/OU AU TIERS",
    4360: "DECISION SUR RECOURS-TRANSMIS COPIE AU SAB",
    4500: "REGISTRE DES MODIFICATIONS-RECU LETTRE DE L'EXPLOITANT",
    4510: "REGISTRE DES MODIFICATIONS-ENCODAGE DES MODIFICATIONS",
    4520: "REGISTRE DES MODIFICATIONS - ENVOI A LA DPA",
    4530: "REGISTRE DES MODIFICATIONS - DPA : NOUVEAU DOSSIER A INTRODU",
    4580: "REGISTRE DES MODIFICATIONS",
    4600: "MODIFICATION DECISION : DEPOT/RECEPTION DE LA DEMANDE",
    4610: "MODIFICATION DECISION : DEMANDE DE L'EXPLOITANT",
    4620: "MODIFICATION DECISION : DEMANDE DU F.T.",
    4630: "MODIFICATION DECISION : DEMANDE DE LA COMMUNE",
    4640: "MODIFICATION DECISION : ENVOI DE LA DEMANDE POUR AVIS AU F.T",
    4649: "MODIFICATION DECISION : RECEPTION DE L'AVIS DU F.T.",
    4650: "MODIFICATION DECISION : F.T. : PAS D'ENQUETE PUBLIQUE",
    4660: "MODIFICATION DECISION : F.T. : ENQUETE PUBLIQUE A REALISER",
    4670: "MODIFICATION DECISION : RECEPTION DU PROJET D'ARRETE",
    4680: "MODIFICATION DECISION : ENVOI PROJET D'ARRETE A L'EXPLOITANT",
    4689: "MODIFICATION DECISION : RECU AVIS DE L'EXPLOITANT SUR ARRETE",
    4690: "MODIFICATION DECISION : EXPLOITANT DEMANDE RDV POUR AUDITION",
    4700: "MODIFICATION DECISION : LETTRE FIXANT RDV A L'EXPLOITANT",
    4710: "MODIFICATION DECISION : PROCE-VERBAL D'AUDITION DE L'EXPLOIT",
    4720: "MODIFICATION DECISION : PAS D'AVIS DE L'EXPLOITANT SUR ARRET",
    5000: "ETABLISSEMENT MOBILES-RECEPTION PERMIS-LIEU-DUREE",
    5100: "PERMIS CADUC-EXPIRATION DU DELAI DE MISE EN OEUVRE",
    5110: "PERMIS CADUC-NON EXPLOITATION DURANT DEUX ANS",
    5200: "ETABLISSEMENT TEMPORAIRE-PROLONGATION-RECEPTION DEMANDE",
    5210: "ETABLISSEMENT TEMPORAIRE-PROLONGATION-DEMANDE D'AVIS AU F.T.",
    5219: "ETABLISSEMENT TEMPORAIRE-PROLONGATION-RECEPTION AVIS DU FT",
    5220: "ETABLISSEMENT TEMPORAIRE-DATES DE MISE EN OEUVRE  DU PERMIS",
    5280: "ETABLISSEMENT TEMPORAIRE",
    5300: "CHANGEMENT D'EXPLOITANT-RECEPTION DEMANDE DE L'EXPLOITANT",
    5310: "CHANGEMENT D'EXPLOITANT-ENVOI FORMULAIRE A EXPLOITANT",
    5320: "CHANGEMENT D'EXPLOITANT-RECU FORMULAIRE SIGNE",
    5321: "CHANGEMENT D'EXPLOITANT-FORMULAIRE REMIS A L'INSPECTEUR",
    5329: "CHANGEMENT D'EXPLOITANT-RETOUR DU FORMULAIRE DE L'INSPECTEUR",
    5330: "CHANGEMENT D'EXPLOITANT-ENVOI PRISE ACTE AU CEDANT",
    5340: "CHANGEMENT D'EXPLOITANT-ENVOI PRISE A CESSIONNAIRE",
    5350: "CHANGEMENT D'EXPLOITANT-ENVOI COPIE FORMULAIRE A DPA",
    5360: "CHANGEMENT D'EXPLOITANT-ENVOI COPIE FORMULAIRE A DPC",
    5380: "CHANGEMENT D'EXPLOITANT",
    5400: "R.C.O. - SANS COUVERTURE D'ASSURANCE",
    5410: "R.C.O. - COURRIER A LA SIGNATURE DU BOURGMESTRE",
    5419: "R.C.O. - RETOUR DU COURRIER SIGNE PAR LE BOURGMESTRE",
    5420: "R.C.O. - LETTRE DE RAPPEL AU CONTREVENANT",
    5430: "R.C.O. - DOSSIER REMIS A L'INSPECTEUR POUR VISITE SUR PLACE",
    5439: "R.C.O. - RETOUR DU DOSSIER DE L'INSPECTEUR",
    5440: "R.C.O. - DEMANDE DE VERBALISATION",
    5450: "R.C.O. - RECEPTION DE LA PREUVE DE MISE EN ORDRE",
    5460: "R.C.O. - PROCHAINE ECHEANCE",
    5480: "R.C.O.",
    5490: "R.C.O.",
    6000: "DECLARATION-REMIS A L'INSPECTEUR DE GARDE",
    6009: "DECLARATION-RETOUR DE L'AVIS DE L'INSPECTEUR DE GARDE",
    6010: "DECLARATION-RECEVABLE SANS CONDITION COMPLEMENTAIRE",
    6020: "DECLARATION-RECEVABLE AVEC COND. COMPLEMENTAIRES/INTEGRALES",
    6030: "DECLARATION-IRRECEVABLE",
    6040: "DECLARATION-RECEVABLE AVEC CONDITIONS ULTERIEURES",
    6050: "DECLARATION-RECEVABLE-TEMPORAIRE AVEC COND COMPL/INTEGRALES",
    6060: "DECLARATION-AUTORISATION TACITE",
    6080: "DECLARATION",
    6100: "DECLARATION-ENVOI DECISION A LA SIGNATURE DU COLLEGE",
    6109: "DECLARATION-RETOUR DECISION SIGNEE PAR LE COLLEGE",
    6110: "DECLARATION-ENVOI DECISION AU DEMANDEUR",
    6120: "DECLARATION-ENVOI DECISION AVEC COND. COMPL. AU DEMANDEUR",
    6130: "DECLARATION-ENVOI CONDITIONS COMPLEMENTAIRES AU DEMANDEUR",
    6140: "DECLARATION-ENVOI CONDITIONS COMPL. MODIFIEES AU DEMANDEUR",
    6150: "DECLARATION-ENVOI COPIE DE LA DECISION A LA DPA",
    6160: "DECLARATION-ENVOI COPIE DE LA DECISION A LA DGATLPE",
    6170: "DECLARATION-ENVOI COPIE DE LA DECISION A LA DPC",
    6180: "DECLARATION-ENVOI COPIE",
    6190: "DECLARATION",
    6200: "DECLARATION-CONCERTATION AVEC AUTRES COMMUNES",
    6210: "DECLARATION-MODIF. DES COND. COMPL.-DEMANDE D'AVIS AU FT",
    6219: "DECLARATION-AVIS DU FT SUR MODIF. DES CONDITIONS COMPL.",
    6300: "DEMANDE DE PRIME-RECU FORMULAIRE DE L'EXPLOITANT",
    6301: "DEMANDE DE PRIME TRANSMISE POUR AVIS AU SERVICE DE LA VOIRIE",
    6309: "DEMANDE DE PRIME-RETOUR DU SERVICE DE LA VOIRIE",
    6310: "DEMANDE DE PRIME-FORMULAIRE TRANSMIS A LA SIGNATURE DU BGM",
    6319: "DEMANDE DE PRIME-RETOUR FORMULAIRE SIGNE PAR BGM",
    6320: "DEMANDE DE PRIME-ENVOI FORMULAIRE SIGNE A L'EXPLOITANT",
    6380: "DEMANDE DE PRIME",
    7000: "DEMANDE DE RENSEIGNEMENTS/DOCUMENTS PAR L'EXPLOITANT",
    7010: "DEMANDE DE RENSEIGNEMENTS/DOCUMENTS PAR LE BOURGMESTRE",
    7020: "DEMANDE DE RENSEIGNEMENTS/DOCUMENTS PAR UN ECHEVIN",
    7030: "DEMANDE DE RENSEIGNEMENTS/DOCUMENTS PAR LE DIRECTEUR",
    7040: "DEMANDE DE RENSEIGNEMENTS/DOCUMENTS PAR UN SERVICE VILLE",
    7050: "DEMANDE DE RENSEIGNEMENTS/DOCUMENTS PAR UNE ADM. PUBLIQUE",
    7060: "DEMANDE DE RENSEIGNEMENTS/DOCUMENTS PAR UN TIERS",
    7070: "DEMANDE DE RENSEIGNEMENTS/DOCUMENTS PAR LA DPA",
    7080: "DEMANDE DE RENSEIGNEMENTS/DOCUMENTS",
    7090: "DEMANDE DE RENSEIGNEMENTS/DOCUMENTS PAR LA DGATLPE",
    7100: "ENVOI DE DOCUMENTS A L'EXPLOITANT",
    7110: "ENVOI DE DOCUMENTS AU BOURGMESTRE",
    7120: "ENVOI DE DOCUMENTS A UN ECHEVIN",
    7130: "ENVOI DE DOCUMENTS A LA DIRECTION",
    7140: "ENVOI DE DOCUMENTS A UN SERVICE VILLE",
    7150: "ENVOI DE DOCUMENTS A UNE ADMINISTRATION PUBLIQUE",
    7160: "ENVOI DE DOCUMENTS A UN TIERS",
    7170: "ENVOI DE DOCUMENTS A LA DPA",
    7171: "ENVOI DE DOCUMENTS A LA DPC",
    7172: "ENVOI DE DOCUMENTS A LA DGATLPE",
    7173: "ENVOI DE DOCUMENTS AU SAB",
    7180: "ENVOI DE DOCUMENTS",
    7200: "RECEPTION DE DOCUMENTS DE L'EXPLOITANT",
    7210: "RECEPTION DE DOCUMENTS DU BOURGMESTRE",
    7220: "RECEPTION DE DOCUMENTS D'UN ECHEVIN",
    7230: "RECEPTION DE DOCUMENTS DE LA DIRECTION",
    7240: "RECEPTION DE DOCUMENTS D'UN SERVICE VILLE",
    7250: "RECEPTION DE DOCUMENTS D'UNE UNE ADMINISTRATION PUBLIQUE",
    7260: "RECEPTION DE DOCUMENTS D'UN TIERS",
    7270: "RECEPTION DE DOCUMENTS DE LA DPA",
    7271: "RECEPTION DE DOCUMENTS DE LA DPC",
    7272: "RECEPTION DE DOCUMENTS DE LA DGATLPE",
    7280: "RECEPTION DE DOCUMENTS DU SAB",
    7290: "RECEPTION DE DOCUMENTS",
    7300: "RECEPTION ATTESTATION DE CONFORMITE",
    7310: "RECEPTION ATTESTATION D'ETANCHEITE",
    7320: "RECEPTION ATTESTATION DE CONTROLE",
    7400: "PLAINTES HORS ENQUETE PARVENUES DIRECTEMENT",
    7410: "PLAINTES HORS ENQUETE VIA LE BOURGMESTRE",
    7420: "PLAINTES HORS ENQUETE VIA UN ECHEVIN",
    7430: "PLAINTES HORS ENQUETE PARVENUES INDIRECTEMENT",
    7480: "PLAINTES HORS ENQUETE",
    7500: "VISITE DE L'ETABLISSEMENT DE L'INSPECTEUR DIVISIONNAIRE",
    7501: "RAPPORT DE VISITE DE L'INSPECTEUR DIVISIONNAIRE",
    7510: "VISITE DE L'ETABLISSEMENT DU F.T. COMPETENT",
    7520: "VISITE PROGRAMMEE DE L'INSPECTEUR DIVISIONNAIRE",
    7530: "VISITE PROGRAMMEE DU FONCTIONNAIRE TECHNIQUE COMPETENT",
    7540: "VISITE PROGRAMMEE DE LA DPC",
    7580: "VISITE PROGRAMMEE",
    7600: "RAPPORT CIRCONSTANCIE DE L'INSPECTEUR DIVISIONNAIRE",
    7610: "RAPPORT CIRCONSTANCIE DU F.T. COMPETENT",
    7680: "RAPPORT CIRCONSTANCIE",
    7700: "IILE-DEMANDE DE VISITE ET/OU D'AVIS",
    7709: "IILE-RECEPTION DU RAPPORT DE VISITE OU DE L'AVIS DE L'IILE",
    7710: "IILE-PRESCRIPTION TRANSMISE A LA SIGNATURE DU BOURGMESTRE",
    7719: "IILE-RETOUR DE LA PRESCRIPTION SIGNEE PAR LE BOURGMESTRE",
    7720: "IILE-ENVOI PRESCRIPTION A L'EXPLOITANT",
    7730: "IILE-ENVOI COPIE PRESCRIPTION A LA DPA",
    7740: "IILE-ENVOI COPIE PRESCRIPTION A LA DGATLPE",
    7750: "IILE-ENVOI COPIE PRESCRIPTION A LA DPC",
    7760: "IILE-ENVOI COPIE PRESCRIPTION",
    7770: "IILE-VISITE PROGRAMMEE",
    7780: "IILE-VISITE DE L'ETABLISSEMENT",
    7790: "IILE",
    7800: "COMMUNE LIMITROPHE-RECU AVIS D'ENQUETE",
    7801: "COMMUNE LIMITROPHE-OBJET DE LA DEMANDE",
    7802: "COMMUNE LIMITROPHE-DATE D'ENQUETE",
    7803: "COMMUNE LIMITROPHE-AVIS D'ENQUETE TRANSMIS AU SAB",
    7804: "COMMUNE LIMITROPHE-ENQUETE A REALISER SUR LIEGE",
    7810: "COMMUNE LIMITROPHE-DOSSIER REMIS A L'INSPECTEUR DE GARDE",
    7811: "COMMUNE LIMITROPHE-AVIS A CLASSER SANS SUITE",
    7819: "COMMUNE LIMITROPHE-RETOUR DU DOSSIER DE L'INSPECTEUR",
    7820: "COMMUNE LIMITROPHE--DOSSIER TRANSMIS AU COLLEGE",
    7829: "COMMUNE LIMITROPHE-RETOUR DU DOSSIER DU COLLEGE",
    7830: "COMMUNE LIMITROPHE-AVIS FAVORABLE DU COLLEGE",
    7831: "COMMUNE LIMITROPHE-AVIS DEFAVORABLE DU COLLEGE",
    7832: "COMMUNE LIMITROPHE-ABSENCE D'AVIS DU COLLEGE",
    7833: "COMMUNE LIMITROPHE-ENVOI DE L'AVIS DU COLLEGE A LA COMMUNE",
    7840: "COMMUNE LIMITROPHE-ENVOI AVIS D'ENQUETE",
    7841: "COMMUNE LIMITROPHE-RECU AVIS DE LA COMMUNE LIMITROPHE",
    7880: "COMMUNE LIMITROPHE",
    7910: "PRESCRIPTION DE NOTRE SERVICE",
    7920: "PRESCRIPTION DE LA DPC",
    7930: "PRESCRIPTION-NOTIFICATION A L'EXPLOITANT",
    7940: "PRESCRIPTION-RAPPEL A L'EXPLOITANT",
    7950: "PRESCRIPTION-CONVOCATION DE L'EXPLOITANT",
    7960: "PRESCRIPTION-MESURES AVANT FERMETURE",
    7980: "PRESCRIPTION",
    8000: "CESSATION D'ACTIVITE",
    8010: "CESSION A UN AUTRE EXPLOITANT",
    8020: "DEPOT D'UNE AUTRE DEMANDE D'EXPLOITER",
    8030: "EXPIRATION DU DELAI DE MISE EN OEUVRE",
    8040: "NON EXPLOITATION DURANT DEUX ANNEES CONSECUTIVES",
    8050: "ABANDON DU PROJET",
    8060: "DOSSIER CLASSE SANS SUITE",
    8070: "DOSSIER REPRIS SOUS UN AUTRE NUMERO",
    8080: "AUTORISATION NON RENOUVELEE",
    8090: "AUTORISATION NON ACCORDEE",
    8100: "FIN FORCEE PAR L'ADMINISTRATION",
    8110: "FIN FORCEE : HORS DELAI DE PROCEDURE",
    8120: "FIN FORCEE HORS DELAI DE PROCEDURE : LETTRE A L'EXPLOITANT",
    8130: "RETRAIT/SUSPENSION TOTAL TEMPORAIRE DE L'AUTORISATION",
    8140: "RETRAIT/SUSPENSION PARTIEL TEMPORAIRE DE L'AUTORISATION",
    8150: "RETRAIT/SUSPENSION TOTAL DEFINITIF DE L'AUTORISATION",
    8160: "RETRAIT/SUSPENSION PARTIEL DEFINITIF DE L'AUTORISATION",
    8170: "LEVEE RETRAIT/SUSPENSION",
    8180: "FIN FORCEERE TOTALE TEMPORAIRE",
    8210: "FERMETURE PARTIELLE TEMPORAIRE",
    8220: "FERMETURE TOTALE DEFINITIVE",
    8230: "FERMETURE PARTIELLE DEFINITIVE",
    8240: "LEVEE TOTALE DE LA FERMETURE",
    8250: "LEVEE PARTIELLE DE LA FERMETURE",
    8260: "DECISION ABROGEE",
    8300: "FIN FORCEE ANTERIEURE A L'ANNEE CONCERNEE",
    8310: "ERREUR-DOSSIER A SUPPRIMER",
    8400: "SITE INOCCUPE ET LIBRE D'EXPLOITATION",
    8500: "E.I.-RECEPTION DE LA DESIGNATION DE L'AUTEUR DU PROJET",
    8510: "E.I.-AUDITION DE L'AUTEUR DU PROJET",
    8520: "E.I.-RECUSATION DE L'AUTEUR : ENVOI DU DOSSIER AU COLLEGE",
    8529: "E.I.-RECUSATION DE L'AUTEUR : RETOUR DU DOSSIER DU COLLEGE",
    8530: "E.I.-COLLEGE - RECUSATION DE L'AUTEUR",
    8540: "E.I.-ENVOI DE LA PROPOSITION DE RECUSATION AU MINISTRE",
    8549: "E.I.-RECEPTION DECISION DU MINISTRE SUR L'AUTEUR DU PROJET",
    8550: "E.I.-LETTRE DE L'EXPLOITANT CONCERNANT LES INFO. A FOURNIR",
    8560: "E.I.-DEMANDE D'AVIS AU CWEDD-INFO. DEMANDEES PAR L'EXP.",
    8569: "E.I. CWEDD-RECU AVIS SUR INFO. DEMANDEES PAR L'EXPLOITANT",
    8570: "E.I.-DEMANDE D'AVIS AU CCAT-INFO. DEMANDEES PAR L'EXPLOITANT",
    8579: "E.I.-CCAT-RECU AVIS SUR INFO. DEMANDEES PAR L'EXPLOITANT",
    8580: "E.I.-DEMANDE D'AVIS A LA DPA-INFO. DEMANDEES PAR L'EXPLOITAN",
    8589: "E.I.-DPA-RECU AVIS SUR INFO. DEMANDEES PAR L'EXPLOITANT",
    8590: "E.I.-DEMANDE D'AVIS A LA DGATLPE-INFO. DEMANDEES PAR EXPLOIT",
    8599: "E.I.-DGATLPE-RECU AVIS SUR INFO. DEMANDEES PAR L'EXPLOITANT",
    8600: "E.I.-LETTRE DE L'EXPLOITANT TRANSMISE A UNE AUTRE ADMINIST.",
    8609: "E.I.-AUTRE ADMINISTRATION-RECU AVIS SUR INFO. DEMANDEES",
    8610: "E.I.-ENVOI A L'EXPLOITANT DE NOTE AVIS SUR INFO. DEMANDEES",
    8620: "E.I.-REUNION DE CONSULTATION-RECEPTION INVITATION",
    8630: "E.I.-REUNION DE CONSULTATION-RECU OBSERVATIONS/SUGGESTIONS",
    8680: "E.I. -",
    8700: "E.I.-DEMANDE A EXP. AVIS PUBLIE CONCERNANT REUNION DE CONSUL",
    8709: "E.I.-RECU AVIS PUBLIE ET FACTURE POUR REUNION DE CONSULTATIO",
    8710: "E.I.-REUNION DE CONSULTATION-ENVOI DES AVIS A L'AFFICHEUR",
    8719: "E.I.-REUNION DE CONSULTATION-RETOUR CERTIFICAT DE L'AFFICHEU",
    8720: "E.I.-REUNION DE CONSULTATION-DEBUT D'AFFICHAGE",
    8730: "E.I.-REUNION DE CONSULTATION-FIN D'AFFICHAGE",
    9000: "DOSSIER REMIS A L'INSPECTEUR",
    9009: "RETOUR DU DOSSIER DE L'INSPECTEUR",
    9010: "DOSSIER REMIS A L'INSPECTEUR -1ER AVIS TECHNIQUE",
    9019: "RETOUR DU DOSSIER DE L'INSPECTEUR",
    9020: "RUBRIQUES-FORMULAIRE A COMPLETER PAR L'INSPECTEUR",
    9029: "RUBRIQUES-RETOUR DU FORMULAIRE COMPLETE PAR L'INSPECTEUR",
    9030: "DOSSIER REMIS A L'INSPECTEUR POUR PRE-RAPPORT",
    9039: "RETOUR DU DOSSIER DE L'INSPECTEUR AVEC PRE RAPPORT",
    9040: "DOSSIER REMIS A L'INSPECTEUR POUR RAPPORT DE SYNTHESE",
    9049: "RETOUR DU DOSSIER DE L'INSPECTEUR AVEC RAPPORT DE SYNTHESE",
    9050: "DOSSIER REMIS A L'INSPECTEUR POUR RAPPORT DECISIONNEL",
    9059: "RETOUR DU DOSSIER DE L'INSPECTEUR AVEC RAPPORT DE SYNTHESE",
    9060: "ENVOI FORMULAIRE CHANGEMENT EXPLOITANT A L'INSPECTEUR",
    9069: "RETOUR DU FORMULAIRE CHANGEMENT D'EXPLOITANT DE L'INSPECTEUR",
    9100: "DOSSIER REMIS AU CHEF DE SERVICE ADMINISTRATIF",
    9110: "DOSSIER REMIS AU CHEF DE BUREAU",
    9120: "DOSSIER REMIS A LA DIRECTION ADMINISTRATIVE",
    9130: "DOSSIER REMIS AU CHEF DE SERVICE TECHNIQUE",
    9140: "DOSSIER REMIS AU BOURGMESTRE",
    9190: "RETOUR DU DOSSIER",
    9200: "ENVOI COURRIER A LA SIGNATURE DU BOURGMESTRE",
    9209: "RETOUR DU COURRIER SIGNE PAR LE BOURGMESTRE",
    9300: "ENVOI COURRIER A LA SIGNATURE DE LA DIRECTION",
    9309: "RETOUR DU COURRIER SIGNE PAR LA DIRECTION",
    9400: "BPA-DEMANDE NOTRE AVIS SUR UNE MANIFESTATION",
    9409: "BPA-ENVOI NOTRE AVIS SUR UNE DEMANDE DE MANIFESTATION",
    9900: "ARCHIVES-DOSSIER CLASSE",
    9901: "ARCHIVES-DOSSIER REPRIS PAR LA CELLULE ADMINISTRATIVE",
    9902: "ARCHIVES-DOSSIER REPRIS PAR LE CHEF DE SERVICE ADMINISTIVES-DOSSIER REPRIS PAR LE CHEF DE BUREAU",
    9904: "ARCHIVES-DOSSIER REPRIS PAR LE DIRECTEUR ADMINISTRATIF",
    9905: "ARCHIVES-DOSSIER REPRIS PAR L'INSPECTEUR DIVISIONNAIRE",
    9906: "ARCHIVES-DOSSIER REPRIS PAR LE DIRECTEUR TECHNIQUE",
    9908: "ARCHIVES-DOSSIER REPRIS PAR",
    9909: "ARCHIVES-DOSSIER RECLASSE",
    9910: "DOSSIER TRANSMIS AUX ARCHIVES GENERALES",
    9911: "DOSSIER SORTI DES ARCHIVES GENERALES",
    9919: "DOSSIER RECLASSE AUX ARCHIVES GENERALES",
},
}
